คุณสามารถใช้วิธีต่อไปนี้เพื่อเพิ่มและนำแต่ละรายการ
ClientUserออกภายใต้
Client
เพิ่มผู้ใช้
คุณสามารถใช้
buyers.clients.users.create
เมธอดเพื่อเชิญบุคคลใหม่ให้เข้าถึง UI ของ Authorized Buyer ในนามของ
ไคลเอ็นต์
เมื่อคุณสร้าง ClientUser ระบบจะตั้งค่า state เป็น INVITED และ Google จะส่งคำเชิญที่คล้ายกับตัวอย่างต่อไปนี้ไปยังอีเมลที่คุณระบุ

บุคคลดังกล่าวต้องคลิกตอบรับคำเชิญ เพื่อรับสิทธิ์เข้าถึง UI ของ Authorized Buyers Marketplace คุณต้องลงชื่อเข้าใช้บัญชี Google เพื่อเข้าถึง UI ของ Authorized Buyers Marketplace
ตัวอย่างต่อไปนี้แสดงวิธีเพิ่ม ClientUser ใหม่ด้วยเมธอด create
REST
ส่งคำขอ
POST https://authorizedbuyersmarketplace.googleapis.com/v1/buyers/12345678/clients/873721984/users?alt=json
Authorization: Bearer ACCESS_TOKEN
Content-Type: application/json
{
"email": "james@luxurymarscruises.mars"
}การตอบกลับ
{
"name": "buyers/12345678/clients/873721984/users/4683251",
"state": "INVITED",
"email": "james@luxurymarscruises.mars"
}Java
/* * Copyright 2022 Google LLC * * Licensed under the Apache License, Version 2.0 (the "License"); * you may not use this file except in compliance with the License. * You may obtain a copy of the License at * * https://www.apache.org/licenses/LICENSE-2.0 * * Unless required by applicable law or agreed to in writing, software * distributed under the License is distributed on an "AS IS" BASIS, * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. * See the License for the specific language governing permissions and * limitations under the License. */ package com.google.api.services.samples.authorizedbuyers.marketplace.v1.buyers.clients.users; import com.google.api.services.authorizedbuyersmarketplace.v1.AuthorizedBuyersMarketplace; import com.google.api.services.authorizedbuyersmarketplace.v1.model.ClientUser; import com.google.api.services.samples.authorizedbuyers.marketplace.v1.Utils; import java.io.IOException; import java.security.GeneralSecurityException; import net.sourceforge.argparse4j.ArgumentParsers; import net.sourceforge.argparse4j.inf.ArgumentParser; import net.sourceforge.argparse4j.inf.ArgumentParserException; import net.sourceforge.argparse4j.inf.Namespace; import org.apache.commons.lang3.RandomUtils; /** * Creates a client user for the given client. * * <p>When a client user is created, the specified email address will receive an email to confirm * access to the Authorized Buyers UI. It will remain in the "INVITED" state and be unable to access * the UI until the specified email has approved of the change. */ public class CreateClientUsers { public static void execute(AuthorizedBuyersMarketplace marketplaceClient, Namespace parsedArgs) { Long accountId = parsedArgs.getLong("account_id"); Long clientId = parsedArgs.getLong("client_id"); String parentClientName = String.format("buyers/%d/clients/%d", accountId, clientId); ClientUser newClientUser = new ClientUser(); newClientUser.setEmail(parsedArgs.getString("email")); ClientUser clientUser = null; try { clientUser = marketplaceClient .buyers() .clients() .users() .create(parentClientName, newClientUser) .execute(); } catch (IOException ex) { System.out.printf("Marketplace API returned error response:%n%s", ex); System.exit(1); } System.out.printf("Created client user for client with name \"%s\":%n", parentClientName); Utils.printClientUser(clientUser); } public static void main(String[] args) { RandomUtils rng = new RandomUtils(); ArgumentParser parser = ArgumentParsers.newFor("CreateClientUsers") .build() .defaultHelp(true) .description(("Creates a client user for the given buyer and client ID.")); parser .addArgument("-a", "--account_id") .help( "The resource ID of the buyers resource under which the client user is to be created." + " This will be used to construct the name used as a path parameter for the" + " users.create request.") .required(true) .type(Long.class); parser .addArgument("-c", "--client_id") .help( "The resource ID of the buyers.clients resource under which the client user is to be" + " created. This will be used to construct the name used as a path parameter for" + " the users.create request.") .required(true) .type(Long.class); parser .addArgument("-e", "--email") .help( "The client user's email address that has to be unique across all client users for " + "a given client. By default, this will be set to a randomly generated email for " + "demonstration purposes.") .type(String.class) .setDefault(String.format("testemail%s@test.com", rng.nextInt(10000000, 99999999))); Namespace parsedArgs = null; try { parsedArgs = parser.parseArgs(args); } catch (ArgumentParserException ex) { parser.handleError(ex); System.exit(1); } AuthorizedBuyersMarketplace client = null; try { client = Utils.getMarketplaceClient(); } catch (IOException ex) { System.out.printf("Unable to create Marketplace API service:%n%s", ex); System.out.println("Did you specify a valid path to a service account key file?"); System.exit(1); } catch (GeneralSecurityException ex) { System.out.printf("Unable to establish secure HttpTransport:%n%s", ex); System.exit(1); } execute(client, parsedArgs); } }
นำผู้ใช้ออก
คุณสามารถใช้เมธอด
buyers.clients.users.delete
เพื่อนำ ClientUser ออก
เช่น คุณสามารถใช้ delete เพื่อเพิกถอนสิทธิ์เข้าถึง
UI ของ Authorized Buyers Marketplace ของบุคคลหนึ่งๆ สำหรับไคลเอ็นต์ที่ระบุอย่างถาวร
หลังจากนำ ClientUser ออกแล้ว คุณต้อง
สร้าง ClientUser ใหม่และบุคคลดังกล่าวต้องตอบรับ
คำเชิญใหม่เพื่อรับสิทธิ์เข้าถึง UI ของ Authorized Buyers Marketplace อีกครั้ง
ตัวอย่างต่อไปนี้แสดงวิธีลบ ClientUser ด้วยเมธอด delete
REST
ส่งคำขอ
DELETE https://authorizedbuyersmarketplace.googleapis.com/v1/buyers/12345678/clients/873721984/users/4573638?alt=json Authorization: Bearer ACCESS_TOKEN Content-Type: application/json
การตอบกลับ
{}Java
/* * Copyright 2022 Google LLC * * Licensed under the Apache License, Version 2.0 (the "License"); * you may not use this file except in compliance with the License. * You may obtain a copy of the License at * * https://www.apache.org/licenses/LICENSE-2.0 * * Unless required by applicable law or agreed to in writing, software * distributed under the License is distributed on an "AS IS" BASIS, * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. * See the License for the specific language governing permissions and * limitations under the License. */ package com.google.api.services.samples.authorizedbuyers.marketplace.v1.buyers.clients.users; import com.google.api.services.authorizedbuyersmarketplace.v1.AuthorizedBuyersMarketplace; import com.google.api.services.samples.authorizedbuyers.marketplace.v1.Utils; import java.io.IOException; import java.security.GeneralSecurityException; import net.sourceforge.argparse4j.ArgumentParsers; import net.sourceforge.argparse4j.inf.ArgumentParser; import net.sourceforge.argparse4j.inf.ArgumentParserException; import net.sourceforge.argparse4j.inf.Namespace; /** * This sample illustrates how to delete a client user for the given buyer, client, and user IDs. */ public class DeleteClientUsers { public static void execute(AuthorizedBuyersMarketplace marketplaceClient, Namespace parsedArgs) { Long accountId = parsedArgs.getLong("account_id"); Long clientId = parsedArgs.getLong("client_id"); Long clientUserId = parsedArgs.getLong("client_user_id"); String name = String.format("buyers/%d/clients/%d/users/%d", accountId, clientId, clientUserId); try { marketplaceClient.buyers().clients().users().delete(name).execute(); } catch (IOException ex) { System.out.printf("Marketplace API returned error response:%n%s", ex); System.exit(1); } System.out.printf("Deleted client user with name \"%s\":%n", name); } public static void main(String[] args) { ArgumentParser parser = ArgumentParsers.newFor("DeactivateClientUsers") .build() .defaultHelp(true) .description(("Delete a client user with the given buyer, client, and user ID.")); parser .addArgument("-a", "--account_id") .help( "The resource ID of the buyers resource under which the parent client was created. " + "This will be used to construct the name used as a path parameter for the " + "users.delete request.") .required(true) .type(Long.class); parser .addArgument("-c", "--client_id") .help( "The resource ID of the buyers.clients resource under which the client user was" + " created. This will be used to construct the name used as a path parameter for" + " the users.delete request.") .required(true) .type(Long.class); parser .addArgument("-u", "--client_user_id") .help( "The resource ID of the buyers.clients.users resource that is being deleted. " + "This will be used to construct the name used as a path parameter for the " + "users.delete request.") .required(true) .type(Long.class); Namespace parsedArgs = null; try { parsedArgs = parser.parseArgs(args); } catch (ArgumentParserException ex) { parser.handleError(ex); System.exit(1); } AuthorizedBuyersMarketplace client = null; try { client = Utils.getMarketplaceClient(); } catch (IOException ex) { System.out.printf("Unable to create Marketplace API service:%n%s", ex); System.out.println("Did you specify a valid path to a service account key file?"); System.exit(1); } catch (GeneralSecurityException ex) { System.out.printf("Unable to establish secure HttpTransport:%n%s", ex); System.exit(1); } execute(client, parsedArgs); } }